import{S as Qs,i as Vs,s as Ws,e as n,k as p,w as _,t as h,M as Xs,c as r,d as e,m as f,a as o,x as w,h as m,b as i,G as a,g as l,y as k,L as Ys,q as g,o as y,B as j,v as Zs}from"../chunks/vendor-hf-doc-builder.js";import{I as $s,C as W}from"../chunks/CodeBlock-hf-doc-builder.js";function se(Ns){let c,X,d,b,J,A,vs,O,_s,Y,E,ws,M,ks,gs,Z,u,S,T,x,ys,D,js,ss,U,bs,es,N,ts,B,Es,as,z,ns,$,q,F,L,Ss,K,qs,rs,C,os,R,Ps,ls,H,is,v,P,Q,I,As,V,xs,ps,G,fs;return A=new $s({}),x=new $s({}),N=new W({props:{code:"pip install safetensors",highlighted:'pip <span class="hljs-keyword">install</span> safetensors'}}),z=new W({props:{code:"conda install -c huggingface safetensors",highlighted:'conda <span class="hljs-keyword">install</span> -c huggingface safetensors'}}),L=new $s({}),C=new W({props:{code:`from safetensors import safe_open

tensors = {}
with safe_open("model.safetensors", framework="pt", device=0) as f:
    for k in f.keys():
        tensors[k] = f.get_tensor(k)`,highlighted:`<span class="hljs-keyword">from</span> safetensors <span class="hljs-keyword">import</span> safe_open

tensors = {}
<span class="hljs-keyword">with</span> safe_open(<span class="hljs-string">&quot;model.safetensors&quot;</span>, framework=<span class="hljs-string">&quot;pt&quot;</span>, device=<span class="hljs-number">0</span>) <span class="hljs-keyword">as</span> f:
    <span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> f.keys():
        tensors[k] = f.get_tensor(k)`}}),H=new W({props:{code:`from safetensors import safe_open

tensors = {}
with safe_open("model.safetensors", framework="pt", device=0) as f:
    tensor_slice = f.get_slice("embedding")
    vocab_size, hidden_dim = tensor_slice.get_shape()
    tensor = tensor_slice[:, :hidden_dim]`,highlighted:`<span class="hljs-keyword">from</span> safetensors <span class="hljs-keyword">import</span> safe_open

tensors = {}
<span class="hljs-keyword">with</span> safe_open(<span class="hljs-string">&quot;model.safetensors&quot;</span>, framework=<span class="hljs-string">&quot;pt&quot;</span>, device=<span class="hljs-number">0</span>) <span class="hljs-keyword">as</span> f:
    tensor_slice = f.get_slice(<span class="hljs-string">&quot;embedding&quot;</span>)
    vocab_size, hidden_dim = tensor_slice.get_shape()
    tensor = tensor_slice[:, :hidden_dim]`}}),I=new $s({}),G=new W({props:{code:`import torch
from safetensors.torch import save_file

tensors = {
    "embedding": torch.zeros((2, 2)),
    "attention": torch.zeros((2, 3))
}
save_file(tensors, "model.safetensors")`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> safetensors.torch <span class="hljs-keyword">import</span> save_file

tensors = {
    <span class="hljs-string">&quot;embedding&quot;</span>: torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)),
    <span class="hljs-string">&quot;attention&quot;</span>: torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">3</span>))
}
save_file(tensors, <span class="hljs-string">&quot;model.safetensors&quot;</span>)`}}),{c(){c=n("meta"),X=p(),d=n("h1"),b=n("a"),J=n("span"),_(A.$$.fragment),vs=p(),O=n("span"),_s=h("Safetensors"),Y=p(),E=n("p"),ws=h("Safetensors is a new simple format for storing tensors safely (as opposed to pickle) and that is still fast (zero-copy). Safetensors is really "),M=n("a"),ks=h("fast \u{1F680}"),gs=h("."),Z=p(),u=n("h2"),S=n("a"),T=n("span"),_(x.$$.fragment),ys=p(),D=n("span"),js=h("Installation"),ss=p(),U=n("p"),bs=h("with pip:"),es=p(),_(N.$$.fragment),ts=p(),B=n("p"),Es=h("with conda:"),as=p(),_(z.$$.fragment),ns=p(),$=n("h2"),q=n("a"),F=n("span"),_(L.$$.fragment),Ss=p(),K=n("span"),qs=h("Load tensors"),rs=p(),_(C.$$.fragment),os=p(),R=n("p"),Ps=h("Loading only part of the tensors (interesting when running on multiple GPU)"),ls=p(),_(H.$$.fragment),is=p(),v=n("h2"),P=n("a"),Q=n("span"),_(I.$$.fragment),As=p(),V=n("span"),xs=h("Save tensors"),ps=p(),_(G.$$.fragment),this.h()},l(s){const t=Xs('[data-svelte="svelte-1phssyn"]',document.head);c=r(t,"META",{name:!0,content:!0}),t.forEach(e),X=f(s),d=r(s,"H1",{class:!0});var hs=o(d);b=r(hs,"A",{id:!0,class:!0,href:!0});var zs=o(b);J=r(zs,"SPAN",{});var Ls=o(J);w(A.$$.fragment,Ls),Ls.forEach(e),zs.forEach(e),vs=f(hs),O=r(hs,"SPAN",{});var Cs=o(O);_s=m(Cs,"Safetensors"),Cs.forEach(e),hs.forEach(e),Y=f(s),E=r(s,"P",{});var ms=o(E);ws=m(ms,"Safetensors is a new simple format for storing tensors safely (as opposed to pickle) and that is still fast (zero-copy). Safetensors is really "),M=r(ms,"A",{href:!0});var Hs=o(M);ks=m(Hs,"fast \u{1F680}"),Hs.forEach(e),gs=m(ms,"."),ms.forEach(e),Z=f(s),u=r(s,"H2",{class:!0});var cs=o(u);S=r(cs,"A",{id:!0,class:!0,href:!0});var Is=o(S);T=r(Is,"SPAN",{});var Gs=o(T);w(x.$$.fragment,Gs),Gs.forEach(e),Is.forEach(e),ys=f(cs),D=r(cs,"SPAN",{});var Ms=o(D);js=m(Ms,"Installation"),Ms.forEach(e),cs.forEach(e),ss=f(s),U=r(s,"P",{});var Us=o(U);bs=m(Us,"with pip:"),Us.forEach(e),es=f(s),w(N.$$.fragment,s),ts=f(s),B=r(s,"P",{});var Bs=o(B);Es=m(Bs,"with conda:"),Bs.forEach(e),as=f(s),w(z.$$.fragment,s),ns=f(s),$=r(s,"H2",{class:!0});var ds=o($);q=r(ds,"A",{id:!0,class:!0,href:!0});var Rs=o(q);F=r(Rs,"SPAN",{});var Js=o(F);w(L.$$.fragment,Js),Js.forEach(e),Rs.forEach(e),Ss=f(ds),K=r(ds,"SPAN",{});var Os=o(K);qs=m(Os,"Load tensors"),Os.forEach(e),ds.forEach(e),rs=f(s),w(C.$$.fragment,s),os=f(s),R=r(s,"P",{});var Ts=o(R);Ps=m(Ts,"Loading only part of the tensors (interesting when running on multiple GPU)"),Ts.forEach(e),ls=f(s),w(H.$$.fragment,s),is=f(s),v=r(s,"H2",{class:!0});var us=o(v);P=r(us,"A",{id:!0,class:!0,href:!0});var Ds=o(P);Q=r(Ds,"SPAN",{});var Fs=o(Q);w(I.$$.fragment,Fs),Fs.forEach(e),Ds.forEach(e),As=f(us),V=r(us,"SPAN",{});var Ks=o(V);xs=m(Ks,"Save tensors"),Ks.forEach(e),us.forEach(e),ps=f(s),w(G.$$.fragment,s),this.h()},h(){i(c,"name","hf:doc:metadata"),i(c,"content",JSON.stringify(ee)),i(b,"id","safetensors"),i(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(b,"href","#safetensors"),i(d,"class","relative group"),i(M,"href","./speed"),i(S,"id","installation"),i(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(S,"href","#installation"),i(u,"class","relative group"),i(q,"id","load-tensors"),i(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(q,"href","#load-tensors"),i($,"class","relative group"),i(P,"id","save-tensors"),i(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(P,"href","#save-tensors"),i(v,"class","relative group")},m(s,t){a(document.head,c),l(s,X,t),l(s,d,t),a(d,b),a(b,J),k(A,J,null),a(d,vs),a(d,O),a(O,_s),l(s,Y,t),l(s,E,t),a(E,ws),a(E,M),a(M,ks),a(E,gs),l(s,Z,t),l(s,u,t),a(u,S),a(S,T),k(x,T,null),a(u,ys),a(u,D),a(D,js),l(s,ss,t),l(s,U,t),a(U,bs),l(s,es,t),k(N,s,t),l(s,ts,t),l(s,B,t),a(B,Es),l(s,as,t),k(z,s,t),l(s,ns,t),l(s,$,t),a($,q),a(q,F),k(L,F,null),a($,Ss),a($,K),a(K,qs),l(s,rs,t),k(C,s,t),l(s,os,t),l(s,R,t),a(R,Ps),l(s,ls,t),k(H,s,t),l(s,is,t),l(s,v,t),a(v,P),a(P,Q),k(I,Q,null),a(v,As),a(v,V),a(V,xs),l(s,ps,t),k(G,s,t),fs=!0},p:Ys,i(s){fs||(g(A.$$.fragment,s),g(x.$$.fragment,s),g(N.$$.fragment,s),g(z.$$.fragment,s),g(L.$$.fragment,s),g(C.$$.fragment,s),g(H.$$.fragment,s),g(I.$$.fragment,s),g(G.$$.fragment,s),fs=!0)},o(s){y(A.$$.fragment,s),y(x.$$.fragment,s),y(N.$$.fragment,s),y(z.$$.fragment,s),y(L.$$.fragment,s),y(C.$$.fragment,s),y(H.$$.fragment,s),y(I.$$.fragment,s),y(G.$$.fragment,s),fs=!1},d(s){e(c),s&&e(X),s&&e(d),j(A),s&&e(Y),s&&e(E),s&&e(Z),s&&e(u),j(x),s&&e(ss),s&&e(U),s&&e(es),j(N,s),s&&e(ts),s&&e(B),s&&e(as),j(z,s),s&&e(ns),s&&e($),j(L),s&&e(rs),j(C,s),s&&e(os),s&&e(R),s&&e(ls),j(H,s),s&&e(is),s&&e(v),j(I),s&&e(ps),j(G,s)}}}const ee={local:"safetensors",title:"Safetensors"};function te(Ns){return Zs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class re extends Qs{constructor(c){super();Vs(this,c,te,se,Ws,{})}}export{re as default,ee as metadata};
